package ink.wgink.gateway.router;

import ink.wgink.gateway.handler.route.RouteHandler;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;
import org.springframework.web.reactive.function.server.*;

/**
 * When you feel like quitting. Think about why you started
 * 当你想要放弃的时候，想想当初你为何开始
 *
 * @ClassName: AllRoutes
 * @Description: 总路由
 * @Author: WangGeng
 * @Date: 2021/4/19 22:57
 * @Version: 1.0
 **/
@Component
public class AllRoutes {

    /**
     * 路由管理
     *
     * @param routeHandler
     * @return
     */
    @Bean
    public RouterFunction<ServerResponse> routeRouter(RouteHandler routeHandler) {
        // 嵌套
        return RouterFunctions.nest(RequestPredicates.path("/route"),
                RouterFunctions
                        .route(RequestPredicates.POST("/save"), routeHandler::save)
                        .andRoute(RequestPredicates.DELETE("/delete/{ids}"), routeHandler::delete)
                        .andRoute(RequestPredicates.PUT("/update/{id}"), routeHandler::update)
                        .andRoute(RequestPredicates.GET("/list"), routeHandler::list)
                        .andRoute(RequestPredicates.GET("get/{id}"), routeHandler::get)
        );
    }

}
